from base_st_classes import *

class ReleaseLockownerSuite(NFSSuite):
    """Test operation 39: RELEASE_LOCKOWNER
    """

    def setUp(self):
        NFSSuite.setUp(self)
        self.fh = None
        self.stateid = None
        self.init_connection()

    def tearDown(self):
        self.ncl.close_file(self.fh, self.stateid, error=None)
        try: self.clean_dir(self.tmp_dir)
        except SkipException, e:
            pass

    #
    # Tests that should work
    #

    # release_lockowner_op not yet defined in nfs4lib
    def testFile(self):
        """RELEASE_LOCKOWNER
        """

        # Create and lock file
        self.fh, self.stateid = self.ncl.create_confirm()
        lockid = self.ncl.lock_file(self.fh, self.stateid)

        # Unlock file
        self.ncl.unlock_file(self.fh, lockid, 1)

        # Release lockowner
        owner = lock_owner4(self.ncl.clientid, "owner")
        ops = [self.ncl.release_lockowner_op(owner)]
        res = self.ncl.do_ops(ops)
        self.assert_OK(res)
